//
//  BlobTool.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Wed Jan 29 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

import java.awt.*;

public class BlobTool extends THSGeneralTool {

    protected int lastmx, lastmy;
    protected int startmx, startmy;
    protected paintbrush curbsh;

    public BlobTool() {
        super();
        curbsh = new squarebrush(1);
    }

    public String getIconImage() {
        return "painticon-1_blob.gif";
    }

    public String getCursorImage() {
        return "";
    }

    public String getString() {
        return "Blob";
    }

    public void mouseDown(int mx, int my, THSCanvas c) {
        lastmx = mx;
        lastmy = my;
        startmx = mx;
        startmy = my;
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.setColor(((PaintCanvas) c).getFGColor());
        Simple.line(gi,curbsh,lastmx,lastmy,mx,my);
    }

    public void mouseDrag(int mx, int my, THSCanvas c) {
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.setColor(((PaintCanvas) c).getFGColor());
        Simple.line(gi,curbsh,lastmx,lastmy,mx,my);
        lastmx = mx;
        lastmy = my;
    }

    public void mouseMove(int mx, int my, THSCanvas c) {}

    public void mouseUp(int mx, int my, THSCanvas c) {
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.setColor(((PaintCanvas) c).getFGColor());
        Simple.line(gi,curbsh,lastmx,lastmy,mx,my);
        Simple.line(gi,curbsh,mx,my,startmx,startmy);
    }

    public boolean keyPressed(Event ke, int k, THSCanvas c) { return false; }
    public boolean keyUp(Event ke, int k, THSCanvas c) { return false; }
    public boolean keyDown(Event ke, int k, THSCanvas c) { return false; }
}
