//
//  THSPanel.java
//  Treehousestudio
//
//  Created by john maeda on Thu Aug 15 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

import java.awt.*;
import java.applet.*;
import java.util.*;

public abstract class THSPanel 
{
   int cx, cy, cw,ch;
   String cs;
   
   THSPanel target;
   THSPanel parent;
   Vector children;
   Hashtable childrenht;
   
   public THSPanel(String _s, int _x, int _y, int _w, int _h) {
       cx = _x;cy = _y; ch = _h; cw = _w; cs = _s;
       children = new Vector();
       childrenht = new Hashtable();
   }
   
   public void setTarget(THSPanel h) {
       target = h;
   }

   public void addChild(THSPanel h) {
       children.addElement(h);
       childrenht.put(h.cs, h);
       h.setParent(this);
   }

   public void setParent(THSPanel h) {
       parent = h;
   }

   public boolean hasChildren() {
       if (children.size() > 0)
           return true;
       return false;
   }
   
   public void err(String s) {
      System.out.println("error: "+s);
   }

   public String getString() {
       return cs;
   }

   public void placeString(Graphics g) {
       g.drawString(cs,cx+(cw - g.getFontMetrics().stringWidth(cs))/2,cy+ch-g.getFontMetrics().getDescent());
   }

   public void placeBorder(Graphics g) {
       g.drawRect(cx,cy,cw,ch);
   }

   public void fill(Graphics g) {
       g.fillRect(cx,cy,cw,ch);
   }

   public boolean insidep(int mx, int my) {
      int s = 2;
      return (mx>cx-s&&mx<cx+cw+s&&my>cy-s&&my<cy+ch+s);
   }

   /**
    * These are to make this type be a true super type
    */

   public abstract void message(String fromWho, Object odat);
   public abstract void mouseDown(Event ev, int x, int y);
   public abstract void mouseUp(Event ev, int x, int y);
   public abstract void mouseDrag(Event ev, int x, int y);
   public abstract boolean keyDown(Event ev, int k);
   public abstract void draw(Graphics g);
   
}
