//
//  IOPortal.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Thu Jan 23 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

import java.sql.*;

public class IOPortal {

    private String user = "root";
    private String password = "swinger";

    private int currUserID;
    private String currUser;
    public IOPortal() {}
    
    public void setUser(String username, int id) {
        currUser = username;
        currUserID = id;
    }

    /**
     * Saves the current image (first passed as a byte array) into the database
     * memory given the username and id.
     */
    public void doSaveImage(int nbytes, byte[] myb) {

        String res;

        // Extract the byte information from the information provided
        int width = (((myb[0] & 0xFF) << 8) | (myb[1] & 0xFF));
        int height = (((myb[2] & 0xFF) << 8) | (myb[3] & 0xFF));

        try {
            Class.forName("org.gjt.mm.mysql.Driver").newInstance();
        } catch (Exception e) {
            System.err.println("Unable to load Driver");
            e.printStackTrace();
        }

        try {
            Connection c = DriverManager.getConnection("jdbc:mysql://localhost/THStudio?user="+user+"&password="+password);
            Statement stmt = c.createStatement();
            ResultSet RS = stmt.executeQuery("SELECT name from images");


            System.out.println("********>> putting "+nbytes+" bytes on the DB");
            while (RS.next()) {
                System.out.println(RS.getString(1));
            }

            RS.close();
            stmt.close();
            c.close();
        } catch (SQLException e) {
            System.out.println("SQLException: " + e.getMessage());
            System.out.println("SQLState:     " + e.getSQLState());
            System.out.println("VendorError:  " + e.getErrorCode());
        }
        
    }

    /**
     * Loads the image with the specified id onto the canvas
     */
    public void doLoad(int id) {

    }
}
